<app-loading *ngIf="isLoading"></app-loading>
<div class="container">
  <div class="wrap-button">
    <mb-button
      *ngIf="isEmail"
      mbButtonType="NO_BORDER"
      mbButtonSize="VERY_LARGE"
      (click)="showModal()"
      mbButtonAvailableStyle="DEFAULT"
      mbButtonText="{{ 'system.templateMng.label.send' | translate }}"
    >
    </mb-button>
    <mb-button
      mbButtonType="NO_BORDER"
      mbButtonSize="VERY_LARGE"
      (click)="submitForm()"
      mbButtonAvailableStyle="PRIMARY"
      mbButtonText="{{ 'system.templateMng.label.save' | translate }}"
    >
    </mb-button>
  </div>
  <div class='app-card'>
    <form nz-form [formGroup]="formUpdate">
      <div class="app-row" nz-row [nzGutter]="[30, 0]">
        <div nz-col nzSm='12' nzLg="6">
          <mb-select
            [mbDataSelects]="listGroup"
            mbKeyLabel="ngrName"
            mbKeyValue="ngrId"
            mbLabelText="{{ 'system.templateMng.label.group' | translate }} <span class='label__required'>*</span>"
            mbPlaceholder="--{{ 'system.templateMng.placeHolder.group' | translate }}--"
            [mbOptionHeightPx]="55"
            formControlName="ngrId"
            [mbType]="isSubmitted && formUpdate.controls['ngrId'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && formUpdate.controls['ngrId'].errors != null"
            [mbErrors]="formUpdate.controls['ngrId'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.group' | translate }
              }
            ]"
            (mbSelect)="selectNotiGroup($event)"
          ></mb-select>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="ntpCode"
            uppercase
            [mbType]="isSubmitted && formUpdate.controls['ntpCode'].errors ? 'error' : 'default'"
            [mbMaxLength]="50"
            [defaultInput]="true"
            [mbShowError]="isSubmitted && formUpdate.controls['ntpCode'].errors != null"
            [mbErrors]="formUpdate.controls['ntpCode'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '50' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.codeTemplate' | translate }
              },
              { errorName: 'code', errorDescription: 'system.validate.code' | translate }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.codeTemplate' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.codeTemplate' | translate }} <span class='label__required'>*</span>"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="ntpName"
            [mbType]="isSubmitted && formUpdate.controls['ntpName'].errors ? 'error' : 'default'"
            [mbMaxLength]="250"
            [defaultInput]="true"
            [mbShowError]="isSubmitted && formUpdate.controls['ntpName'].errors != null"
            [mbErrors]="formUpdate.controls['ntpName'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '250' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.nameTemplate' | translate }
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.nameTemplate' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.nameTemplate' | translate }} <span class='label__required'>*</span>"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="subject"
            [mbType]="isSubmitted && formUpdate.controls['subject'].errors ? 'error' : 'default'"
            [mbMaxLength]="100"
            [defaultInput]="true"
            [mbShowError]="isSubmitted && formUpdate.controls['subject'].errors != null"
            [mbErrors]="formUpdate.controls['subject'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.title' | translate }
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.title' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.title' | translate }} <span class='label__required'>*</span>"
          >
          </mb-input-text>
        </div>
      </div>
      <div class="app-row" nz-row [nzGutter]="[30, 0]" *ngIf="isEmail; else elseTpl">
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="fromAddress"
            [mbType]="isSubmitted && formUpdate.controls['fromAddress'].errors ? 'error' : 'default'"
            [mbMaxLength]="100"
            [mbShowError]="isSubmitted && formUpdate.controls['fromAddress'].errors != null"
            [mbErrors]="formUpdate.controls['fromAddress'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.mailingAddress' | translate }
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.mailingAddress' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.mailingAddress' | translate }} <span class='label__required'>*</span>"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="mailCC"
            [mbType]="isSubmitted && formUpdate.controls['mailCC'].errors ? 'error' : 'default'"
            [mbMaxLength]="500"
            [mbShowError]="isSubmitted && formUpdate.controls['mailCC'].errors != null"
            [mbErrors]="formUpdate.controls['mailCC'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '500' }
              },
              {
                errorName: 'mailValidator',
                errorDescription: 'system.validate.mailValidator' | translate
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.cc' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.cc' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="mailBCC"
            [mbType]="isSubmitted && formUpdate.controls['mailBCC'].errors ? 'error' : 'default'"
            [mbMaxLength]="200"
            [mbShowError]="isSubmitted && formUpdate.controls['mailBCC'].errors != null"
            [mbErrors]="formUpdate.controls['mailBCC'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '200' }
              },
              {
                errorName: 'mailValidator',
                errorDescription: 'system.validate.mailValidator' | translate
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.bcc' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.bcc' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="toAddress"
            [mbType]="isSubmitted && formUpdate.controls['toAddress'].errors ? 'error' : 'default'"
            [mbMaxLength]="200"
            [mbShowError]="isSubmitted && formUpdate.controls['toAddress'].errors != null"
            [mbErrors]="formUpdate.controls['toAddress'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '200' }
              },
              {
                errorName: 'mailValidator',
                errorDescription: 'system.validate.mailValidator' | translate
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.receiver' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.receiver' | translate }}"
          >
          </mb-input-text>
        </div>
      </div>

      <ng-template #elseTpl>
        <div class="app-row" nz-row [nzGutter]="[30, 0]">
          <div nz-col nzSm='12' nzLg="6">
            <mb-input-text
              formControlName="notiLink"
              [mbType]="isSubmitted && formUpdate.controls['notiLink'].errors ? 'error' : 'default'"
              [mbMaxLength]="100"
              [mbShowError]="isSubmitted && formUpdate.controls['notiLink'].errors != null"
              [mbErrors]="formUpdate.controls['notiLink'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'maxlength',
                  errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
                },
                { errorName: 'url', errorDescription: 'system.validate.url' | translate}
              ]"
              mbPlaceholderText="--{{ 'system.templateMng.placeHolder.link' | translate }}--"
              mbLabelText="{{ 'system.templateMng.label.link' | translate }}"
            >
            </mb-input-text>
          </div>
          <div nz-col nzSm='12' nzLg="6">
            <mb-input-text
              formControlName="pushNotiLink"
              [mbType]="isSubmitted && formUpdate.controls['pushNotiLink'].errors ? 'error' : 'default'"
              [mbMaxLength]="100"
              [mbShowError]="isSubmitted && formUpdate.controls['pushNotiLink'].errors != null"
              [mbErrors]="formUpdate.controls['pushNotiLink'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'maxlength',
                  errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
                },
                { errorName: 'url', errorDescription: 'system.validate.url' | translate }
              ]"
              mbPlaceholderText="--{{ 'system.templateMng.placeHolder.mobileLink' | translate }}--"
              mbLabelText="{{ 'system.templateMng.label.mobileLink' | translate }}"
            >
            </mb-input-text>
          </div>
          <div nz-col nzSm='12' nzLg="6">
            <mb-input-text
              formControlName="toAddress"
              [mbType]="isSubmitted && formUpdate.controls['toAddress'].errors ? 'error' : 'default'"
              [mbMaxLength]="200"
              [mbShowError]="isSubmitted && formUpdate.controls['toAddress'].errors != null"
              [mbErrors]="formUpdate.controls['toAddress'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'maxlength',
                  errorDescription: 'system.validate.maxLength' | translate: { numberLength: '200' }
                },
                {
                  errorName: 'mailValidator',
                  errorDescription: 'system.validate.mailValidator' | translate
                }
              ]"
              mbPlaceholderText="--{{ 'system.templateMng.placeHolder.receiver' | translate }}--"
              mbLabelText="{{ 'system.templateMng.label.receiver' | translate }}"
            >
            </mb-input-text>
          </div>
          <div nz-col nzSm='12' nzLg="6">
            <mb-select
              [mbDataSelects]="listStatus"
              mbKeyLabel="label"
              mbKeyValue="value"
              mbLabelText="{{ 'system.templateMng.label.status' | translate }} <span class='label__required'>*</span>"
              mbPlaceholder="--{{ 'system.templateMng.placeHolder.status' | translate }}--"
              [mbOptionHeightPx]="55"
              formControlName="flagStatus"
              [mbType]="isSubmitted && formUpdate.controls['flagStatus'].errors ? 'error' : 'default'"
              [mbShowError]="isSubmitted && formUpdate.controls['flagStatus'].errors != null"
              [mbErrors]="formUpdate.controls['flagStatus'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'required',
                  errorDescription:
                    'system.validate.required'
                    | translate: { param: 'system.templateMng.label.status' | translate }
                }
              ]"
            ></mb-select>
          </div>
        </div>
      </ng-template>

      <div class="app-row" nz-row [nzGutter]="[30, 0]" *ngIf="isEmail">
        <div nz-col nzSm='12' nzLg="6">
          <div class='label-password'>
            <label class="input__label">{{ 'system.templateMng.label.mailingPassword' | translate }}</label>
          </div>
          <div style="position: relative">
            <input
              class="create-template-card__left__input"
              formControlName="fromPassword"
              type="password"
              autocomplete="on"
              #passwordInput
              nz-input
              placeholder="--{{ 'system.templateMng.placeHolder.mailingPassword' | translate }}--"
            />
            <em
              nz-icon
              class="create-template-card__left__icon"
              [nzType]="passwordVisible ? 'eye-invisible' : 'eye'"
              (click)="changeTypeInput()"
            ></em>
          </div>
        </div>
        <div nz-col nzSm='12' nzLg="6" *ngIf="isNoti && isEmail">
          <mb-input-text
            formControlName="notiLink"
            [mbType]="isSubmitted && formUpdate.controls['notiLink'].errors ? 'error' : 'default'"
            [mbMaxLength]="100"
            [mbShowError]="isSubmitted && formUpdate.controls['notiLink'].errors != null"
            [mbErrors]="formUpdate.controls['notiLink'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
              },
              {
                errorName: 'mailValidator',
                errorDescription: 'system.validate.mailValidator' | translate
              }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.link' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.link' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6" *ngIf="isNoti && isEmail">
          <mb-input-text
            formControlName="pushNotiLink"
            [mbType]="isSubmitted && formUpdate.controls['pushNotiLink'].errors ? 'error' : 'default'"
            [mbMaxLength]="100"
            [mbShowError]="isSubmitted && formUpdate.controls['pushNotiLink'].errors != null"
            [mbErrors]="formUpdate.controls['pushNotiLink'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '100' }
              },
              { errorName: 'url', errorDescription: 'system.validate.url' | translate }
            ]"
            mbPlaceholderText="--{{ 'system.templateMng.placeHolder.mobileLink' | translate }}--"
            mbLabelText="{{ 'system.templateMng.label.mobileLink' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-select
            [mbDataSelects]="listStatus"
            mbKeyLabel="label"
            mbKeyValue="value"
            mbLabelText="{{ 'system.templateMng.label.status' | translate }} <span class='label__required'>*</span>"
            mbPlaceholder="--{{ 'system.templateMng.placeHolder.status' | translate }}--"
            [mbOptionHeightPx]="55"
            formControlName="flagStatus"
            [mbType]="isSubmitted && formUpdate.controls['flagStatus'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && formUpdate.controls['flagStatus'].errors != null"
            [mbErrors]="formUpdate.controls['flagStatus'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.templateMng.label.status' | translate }
              }
            ]"
          ></mb-select>
        </div>
      </div>
      <div class="app-row" nz-row [nzGutter]="[30, 0]">
        <div
          nz-col
          nzSpan="24"
          *ngIf="isNoti || (isNoti && isEmail)"
        >
          <div class='label-password'>
            <label class="input__label">{{ 'system.templateMng.label.shortContent' | translate }}</label>
          </div>
          <textarea rows="6" nz-input formControlName="shortContent"></textarea>
        </div>
        <div nz-col nzSpan="24" class="create-template-card__left editor">
          <div class='label-password'>
            <label class="input__label">{{ 'system.templateMng.label.detailContent' | translate }}</label>
          </div>
          <div>
            <quill-editor [modules]="modules" formControlName="content" appendTo="#editor"></quill-editor>
          </div>
        </div>
      </div>
    </form>
  </div>
  <nz-modal
    [(nzVisible)]="isVisible"
    nzTitle="Gửi thử email"
    nzOkText="Gửi"
    (nzOnCancel)="handleCancel()"
    (nzOnOk)="handleOk()"
  >
    <ng-container *nzModalContent>
      <mb-input-text
        [(ngModel)]="toAddress"
        mbPlaceholderText="--{{ 'system.templateMng.label.toAddress' | translate }}--"
        mbLabelText="{{ 'system.templateMng.label.toAddress' | translate }}"
      >
      </mb-input-text>
    </ng-container>
  </nz-modal>
</div>
